module VECTOR3 =
struct
	type t = float * float * float
	let len = fun (a,b,c) -> sqrt(a*.a +. b*.b +. c*.c)	
	let angle = fun (a,b,c) -> fun (d,e,f) -> acos((a*.d +. b*.e +. c*.f) /. sqrt((a*.a +. b*.b +. c*.c)*.(d*.d +. e*.e +. f*.f)))
	let product = fun ((a11,a12,a13),(a21,a22,a23),(a31,a32,a33)) -> fun (c,d,e) -> (c*.a11 +. d*.a21 +. e*.a31, 
	                                                                                 c*.a12 +. d*.a22 +. e*.a32, 
	                                                                                 c*.a13 +. d*.a23 +. e*.a33)
end;;

VECTOR3.angle (1.,2.,3.) (2.,3.,4.);;
VECTOR3.product((1.,2.,3.),(1.,1.,1.),(1.,1.,1.)) (1.,2.,3.);;
